#!/usr/bin/python

import Tkinter
from Tkinter import *
import sys
if sys.platform == 'win32' :
    POVEDITHOME = 'c:\\source\\povedit'
else :
    POVEDITHOME='/usr/local/povedit'


sys.path.append(POVEDITHOME)



import myglobal
from myglobal import g as Global



import Pmw




###########################################
#
# Utilitaires
# Helper functions
###########################################

    


def PortFolio(arg=None):
    import gestionimages
    Global.PortFolio = gestionimages.Portfolio(root)




def popo(arg=None):
    v =Global.Interface.PortFolio.get()
    if v == 1 and Global.PortFolio == None :
        PortFolio()
        return
    if v == 1 and Global.PortFolio != None :
        return
    if v == 0 and Global.PortFolio == None :
        return
    if v == 0 and Global.PortFolio != None :
        Global.PortFolio.buttonok()
    

def MiseAJour(arg=None):
    import http
    http.MiseAJour(root)



def SelectFont(arg=None):
    """Choix de la police de l'editeur courant"""
    from fontselect import fontselect as fontselect
    fs = fontselect(root)
    fs.run()
    GetCurrentEditor().configure(font = Global.font)
   



def NotImplemented():
    Pmw.MessageDialog(None,defaultbutton = 0,message_text =povmessages[0])




def ChargeImages(size):
    """ va chercher les images nommees [A-Z]*.gif dans icons
    cree des PhotoImage et les range dans la liste Global.image"""
    import glob
    if size == 'small' :
        s = "%s%sicons%ssmall%s[A-Z]*.gif"%(POVEDITHOME,os.sep,os.sep,os.sep)
    else :
        s = "%s%sicons%s[A-Z]*.gif"%(POVEDITHOME,os.sep,os.sep)
    for i  in glob.glob(s):
        im = PhotoImage(file=i)
        Global.image.append((im,i))

    try :
        im = PhotoImage(file="%s%sicons%ssplah.gif"%(POVEDITHOME,os.sep,os.sep))
        Global.splash = im
    except : pass
    







## def LectureConfig():
##     """ tente de lire le fichier ~/.poveditrc
##     si impossible, renvoie 0
##     sinon, il est sommairement parse et renvoie 1"""
##     return Global.read()




def EntryToCmd(str):
    """ a virer ?

    sert a traduire en commandes pov le contenu de la combo"""
    return str
    sz = str.split()
    return "+W%s +H%s "%(sz[0].split('x')[0],sz[0].split('x')[1])
    

      

def GetCurrentEditor():
    """ renvoie l'editeur courant
    appele un peu partout"""
    num =Global.Interface.notebook.index(Pmw.SELECT)
    editor = Global.Interface.ListEditors[num]
    return editor


##############################   MENU 1 #########################################



def NewFile(arg=None):
    npages = Global.Interface.notebook.index(Pmw.END,1)
    ListeNoms=[]
    for i in Global.Interface.notebook.pagenames():
        ListeNoms.append(i)
    i = 0
    name = "%s%d"%(povmessages[1],i)
    while name in ListeNoms :
        i = i+1
        name = "%s%d"%(povmessages[1],i)
    return AddPage(name,0)

def OpenFile(arg=None):
    import tkFileDialog
    filetypes = [('Pov files', '.pov'),('Include files', '.inc'),  ('All files', '*')]
    fname = tkFileDialog.askopenfilename(filetypes=filetypes)
                                   
    if not fname : return
    tt = AddPage(fname,1)
    color()
    
def InsertFile(arg=None):
    import tkFileDialog
    filetypes = [('Pov files', '.pov'),('Include files', '.inc'),  ('All files', '*')]
    fname = tkFileDialog.askopenfilename(filetypes=filetypes)
    if not fname : return
    editor = GetCurrentEditor()
    editor.insert(INSERT,open(fname).read())
    color()
      
def Close(arg=None):
    num =Global.Interface.notebook.index(Pmw.SELECT)
    if num == 0 : return 0
    Interface.notebook.delete(num)
    Interface.ListEditors.pop(num)
    Interface.ListFileNames.pop(num)
    return 1
    

def CloseAll():
    while Close() :
        pass
     
def Save(a=None):
    num =Global.Interface.notebook.index(Pmw.SELECT)
    editor = Interface.ListEditors[num]
    print num,Interface.ListFileNames
    name = Interface.ListFileNames[num]
    s = editor.get(1.0, END)
    open(name,'w+').write(s)
    print num,Interface.ListFileNames
    
def SaveAs(a=None):
    import tkFileDialog
    fname = tkFileDialog.asksaveasfilename()
    if not fname : return
    num =Global.Interface.notebook.index(Pmw.SELECT)
    editor = Interface.ListEditors[num]
    s = editor.get(1.0, END)
    open(fname,'w+').write(s)

def SaveAll(a=None):
    for i in Interface.notebook.pagenames() :
                 Interface.notebook.selectpage(i)
                 Save()


def Print():
    import os
    (child_stdin, child_stdout, child_stderr) = os.popen3('lpr')
    num =Interface.notebook.index(Pmw.SELECT)
    editor = Interface.ListEditors[num]
    s = editor.get(1.0, END)
    child_stdin.write(s)

def Exit():
    Global.save()
    KillAll()
    root.destroy()

###################### fin de menu 1   #############################################

##############################   MENU 2   #########################################

def Undo(arg=None):
    num =Global.Interface.notebook.index(Pmw.SELECT)
    editor = Interface.ListEditors[num]
    etat = Interface.ListeEtats[num]
    if etat == 0 : return
    etat = etat - 1;
    PileEtats = Interface.ListePileEtats[num]
    editor.delete(1.0,END)
    str = PileEtats[etat]
    editor.insert(1.0,str)
    Interface.ListeEtats[num] = etat
    
def Redo(arg=None):
    num =Global.Interface.notebook.index(Pmw.SELECT)
    editor = Interface.ListEditors[num]
    etat = Interface.ListeEtats[num]
    if etat == len(Interface.ListePileEtats[num]) - 1 : return
    PileEtats = Interface.ListePileEtats[num]
    if len(PileEtats) <= etat : return
    editor.delete(1.0,END)
    str = PileEtats[etat+1]
    editor.insert(1.0,str)
    Interface.ListeEtats[num] = etat+1
    
def Cut(arg=None):
    editor = GetCurrentEditor()
    if len(editor.tag_ranges('sel')) == 0 : return
    Global.NotePad = editor.get(SEL_FIRST,SEL_LAST)
    editor.delete(SEL_FIRST,SEL_LAST)
    
def Copy(arg=None):
    editor = GetCurrentEditor()
    if len(editor.tag_ranges('sel')) == 0 : return
    Global.NotePad = editor.get(SEL_FIRST,SEL_LAST)

def Paste(arg=None):
    if Global.NotePad == None : return
    editor = GetCurrentEditor()
    editor.insert(INSERT,Global.NotePad)

def Delete(arg=None):
    print "kjhkjh"
    editor = GetCurrentEditor()
    if len(editor.tag_ranges('sel')) == 0 : return
    editor.delete(SEL_FIRST,SEL_LAST)
    
def Hide(arg=None):
    editor = GetCurrentEditor()
    try :
        Global.hidden[editor.index(SEL_FIRST)] = editor.get(SEL_FIRST,SEL_LAST)
        editor.delete(SEL_FIRST,SEL_LAST)
    except : pass


def Montrer(arg=None):
    editor = GetCurrentEditor()
    try :
        for index in Global.hidden.keys() :
            editor.insert(index,Global.hidden[index])
        Global.hidden = {}
    except : pass
    
def SelectAll(arg=None):
    editor = GetCurrentEditor()
    editor.tag_add(SEL,1.0,END)
    editor.update()


    
def SpaceToTabs (arg=None):
    tabsize = 5
    editor = GetCurrentEditor()
    str = editor.get(0.1,END).replace(" "*tabsize,"\t")
    editor.delete(0.1,END)
    editor.insert(0.1,str)

    
def TabsToSpace (arg=None):
    tabsize = 5
    editor = GetCurrentEditor()
    str = editor.get(0.1,END).replace("\t"," "*tabsize)
    editor.delete(0.1,END)
    editor.insert(0.1,str)
    
def UpperCase(arg=None):
    editor = GetCurrentEditor()
    try :
        left = editor.get(0.1,SEL_FIRST)
        middle = editor.get(SEL_FIRST,SEL_LAST)
        right = editor.get(SEL_LAST,END)
        editor.delete(0.1,END)
        editor.insert(0.1,left)
        editor.insert(END,middle.upper())
        editor.insert(END,right)
    except : pass


def LowerCase(arg=None):
    editor = GetCurrentEditor()
    try :
        left = editor.get(0.1,SEL_FIRST)
        middle = editor.get(SEL_FIRST,SEL_LAST)
        right = editor.get(SEL_LAST,END)
        editor.delete(0.1,END)
        editor.insert(0.1,left)
        editor.insert(END,middle.lower())
        editor.insert(END,right)
    except : pass

###################### fin de menu 2  #############################################




##############################   MENU 3   #########################################
    
class _Find:
    def __init__(self, parent):
        self.top = Toplevel(parent)
        self.top.geometry("158x82+20+20")
        
        Label(self.top, text=povmessages[6]).pack()
        self.e = Entry(self.top)
        self.top.bind("<Return>",Find )
        self.e.pack(padx=5)
        b = Button(self.top,text="OK", command=self.ok)
        b.pack(pady=5)
        Global.PointeurSurFind = self

    def ok(self):
        
        Global.StringToFind =  self.e.get()
        Global.Interface.VariablePourFind.set(Global.Interface.VariablePourFind.get()+1)
        Find()
        #print self.top.geometry()
        #self.top.destroy()

    
def Find(arg=None):
    #arg vaut None si depuis menu
    editor = GetCurrentEditor()
    if Global.PointeurSurFind == None :
         Global.PointeurSurFind = _Find(root)
         root.wait_variable(Global.Interface.VariablePourFind)
    _len =  len(Global.StringToFind)
    if _len == 0 : return
    pos = editor.search(Global.StringToFind,INSERT)
    if pos == None or len(pos) == 0 : return
    editor.tag_add("clignotant", pos,"%s + %d chars"%(pos,_len))
    editor.tag_config("clignotant", foreground="red")
    editor.update_idletasks()





    
class _Replace:
    def __init__(self, parent):
        self.top = Toplevel(parent)
        #self.top.geometry("158x82+20+20")
        
        Label(self.top, text=povmessages[6]).pack()
        self.e1 = Entry(self.top)
        self.top.bind("<Return>",Find )
        self.e1.pack(padx=5)
        
        Label(self.top, text=povmessages[7]).pack()
        self.e2 = Entry(self.top)
        self.top.bind("<Return>",Find )
        self.e2.pack(padx=5)

        b = Button(self.top,text="OK", command=self.ok)
        b.pack(pady=5)
        Global.PointeurSurFind = self

    def ok(self):
        
        Global.StringToFind =  self.e1.get()
        
        Global.StringToReplace =  self.e2.get()
        Global.Interface.VariablePourFind.set(Global.Interface.VariablePourFind.get()+1)
        Replace()




    
def Replace(arg=None):
    #arg vaut None si depuis menu
    editor = GetCurrentEditor()
    if Global.PointeurSurFind == None :
         Global.PointeurSurFind = _Replace(root)
         root.wait_variable(Global.Interface.VariablePourFind)
    _len =  len(Global.StringToFind)
    if _len == 0 : return
    pos = editor.search(Global.StringToFind,INSERT)
    if pos == None : return
    #print pos
    editor.delete( pos,"%s + %d chars"%(pos,_len))
    editor.insert( pos,Global.StringToReplace)


def FindNext( arg=None):
    Find()



    
def PositionParentheseAssociee(editor):
    """ appelee par MatchBrace ; renvoie l'index de la par associee ou none"""
    size = len(editor.get(1.0,END))
    posini = editor.index(INSERT)
    if  editor.get('insert') == '{':
        index = 0
        for i in range(size):
            #print i,index, editor.get('insert + %d chars'%i)
            if  editor.get('insert + %d chars'%i) == '}': index = index - 1
            if  editor.get('insert + %d chars'%i) == '{': index = index + 1
            if index == 0 : return 'insert + %d chars'%i
    if  editor.get('insert') == '}':
        index = 0
        ok = 0
        for i in range(size):
            #print i,index, editor.get('insert - %d chars'%i)
            if  editor.get('insert - %d chars'%i) == '}': index = index - 1;ok=1
            if  editor.get('insert - %d chars'%i) == '{': index = index + 1;ok=1
            if index == 0 and ok == 1: return 'insert - %d chars'%i
    return None
        
  
    
def MatchBrace(arg=None):
    """ appariement de parentheses
    appelle PositionParentheseAssociee qui renvoie None ou la position de la parenthese associee
    sous la forme             insert + %d chars """
    editor = GetCurrentEditor()
    old = editor.index(INSERT)
    n = PositionParentheseAssociee(editor)
    editor.tag_remove('parenthese',0.1,END)
    if n != None :
        editor.tag_add('parenthese',old)
        editor.tag_config("parenthese", background = 'red',foreground="green",relief = GROOVE ) 
        editor.tag_add('parenthese',editor.index(n))
        editor.tag_config("parenthese", background = 'red',foreground="green",relief = GROOVE )    

class _GotoLine:
    def __init__(self, parent):
        self.top = Toplevel(parent)
        #self.top.geometry("158x82+20+20")
        
        Label(self.top, text=povmessages[2]).pack()
        self.e1 = Entry(self.top)
        self.top.bind("<Return>",GotoLine )
        self.e1.pack(padx=5)
        b = Button(self.top,text="OK", command=self.ok)
        b.pack(pady=5)
        Global.PointeurSurGotoLine=self

    def ok(self):
        Global.Interface.VariablePourGotoLine.set(Global.Interface.VariablePourGotoLine.get()+1)
        GotoLine()

def GotoLine(arg=None):
    if Global.PointeurSurGotoLine == None :
         Global.PointeurSurGotoLine = _GotoLine(root)
         root.wait_variable(Global.Interface.VariablePourGotoLine)
    editor = GetCurrentEditor()
    #root.wait_window(t.top)
    #print editor.index(INSERT)
    num = Global.PointeurSurGotoLine.e1.get()
    
    editor.tag_add("mlml","%s.0"%num,"%s.end"%num)
    editor.tag_config("mlml", foreground="red")
    
    

##############################   MENU 4   #########################################


def ShowWhiteSpace(s):
    import string
    ret=[]
    listelignes = s.split("\n")
    for lig in listelignes :
        for i in range(len(lig)):
            if lig[i] != ' ' :  break
        lig = '*'*i+lig[i:]
        ret.append(lig)
    return  string.join(ret,'\n')
    
def SetRepeatCount(arg=None):
    t=MyDialog(None,povmessages[8])
    root.wait_window(t.top)
    Interface.Config_SetRepeatCount.set(Global.vv)


    

###################### fin de menu4 ################################




##############################   MENU 5   #########################################

###################### fin de menu5  #############################################
    
    

##############################   MENU 6   #########################################

def Inserer(event=None):
    global menu
    if event : menu.post(event.x_root, event.y_root)
    else : menu.post(20,10)

###################### fin de menu6  #############################################

    
###############" pas de menu6 : insert ################################


##############################   MENU 7   #########################################
    
def ChoixFichierConfig(but=None,text=None):
    import tkFileDialog
    fname = tkFileDialog.Open().show()
    if fname == None : return
    but.configure(text=fname)
    Global.FichierConfigPPal=fname
    text.delete(0.1,END)
    text.insert(0.1, open(fname).read())
   



def EditSettingsRenderBOK(editor1=None,editor2 = None,toplevel=None):
    
    Global.ListeOptions = []
    #Interface.frame2.combo.clear()
    Global.Interface.frame2.combo.delete(0,END)
    listoptions = editor2.get(1.0,END)
    listoptions = listoptions.split('\n')
    
    for l in listoptions:
        if(len(l)) > 0 :
            Interface.frame2.combo.insert(0,l)
            Global.ListeOptions.append(l)
    #print Global.ListeOptions
        
    Interface.frame2.combo.selectitem(0)
    newmainfile =  editor1.get(1.0,END)
    open( Global.FichierConfigPPal ,'w').write(newmainfile)
    
    toplevel.destroy()
    
def EditSettingsRender(arg=None):
    t = Toplevel(None)
    t.grab_set()
    framehaut = Frame(t)
    labelhaut = Label(framehaut)
    buttonhaut = Button(framehaut,text = Global.FichierConfigPPal)
    buttonhaut.grid(row=0,column=1)
    labelhaut.grid(row=0,column=0)
    framehaut.grid(row=0,column=0,columnspan=2)
    txt1 = Text(t)
    #txt1['font'] = Global.police
    #txt1.configure(font=Global.police,bg="white",width=40,height=10)
    
    buttonhaut.configure(command=lambda a=buttonhaut,b=txt1: ChoixFichierConfig(a,b))
    
    text1 = open( Global.FichierConfigPPal).read()
    #print text1, Global.FichierConfigPPal
    txt1.insert(0.1,text1)
    txt1.grid(row = 1,column = 0,columnspan=2)
    
    txt2 = Text(t)
    #txt2.configure(font=Global.police,bg="white",width=40,height=10)

    for i in range(Global.Interface.frame2.combo.size()):
        txt2.insert(END,Global.Interface.frame2.combo.get(i)+'\n')
    txt2.grid(row = 2,column = 0,columnspan=2)
    bquit = Button(t,text='OK',command = lambda a=txt1,b=txt2,c=t : EditSettingsRenderBOK(a,b,c))
    bquit.grid(row = 3,column = 0)
    bcancel = Button(t,text='Cancel',command=t.destroy)
    bcancel.grid(row = 3,column = 1,sticky=E+W ,padx=5, pady=5)
    root.wait_window(t)


def SelectFileAndRender(arg=None):
    OpenFile()
    Visu()
 
    
def Visu(arg=None):
    Montrer()
    Global.Interface.StartRender()
        
    
def Visu1(arg=None):
    Montrer()
    Global.Interface.StartParallelRender()
        
def Controle(arg=None):
    import control
    editor = GetCurrentEditor()
    if len(editor.tag_ranges('sel')) == 0 :
        from tkMessageBox import showerror
        showerror(povmessages[3],povmessages[4])
        return
    text1 = editor.get(0.1,SEL_FIRST)
    text2 = editor.get(SEL_FIRST,SEL_LAST)
    text3 = editor.get(SEL_LAST,END)
    
    t = control.Control(None,text1,text2,text3)
    root.wait_window(t.tl)
    return


def KillAll(arg=None):
    """Detruit toutes les instances de povray. Necessaire pour sortir proprement"""
    import os
    os.system("killall -9 %s 2> /dev/null"%Global.AdresseDePOV)
###################### fin de menu7  ################################


##############################   MENU 8   #########################################


def LancerServeur(arg=None):
    import thread
    from povserver import dispatcher as dispatcher
    thread.start_new_thread(dispatcher,())

    



def DetectionServers(text=None,listeservactifs=[],resu=[]):
    from socket import *
    lastline = int(text.index(END).split('.')[0])
    for i in range(1,lastline):
         adresse = text.get("%d.0"%i,"%d.end"%i)
         if len(adresse) == 0 : continue
         serverHost = adresse
         serverPort = 50007
         try :
             sockobj = socket(AF_INET, SOCK_STREAM)
             sockobj.connect((serverHost, serverPort))
             listeservactifs.insert(0,adresse)
             Global.ListeServeursActifs.append((sockobj,"Select"))
             resu.append((sockobj,"Select"))
         except :
             print 'probleme connexion vers '+adresse
    
def ChoixServeurs_bok(liste=None,tl=None):
    Global.ListeServeursActifs = liste
    print liste
    tl.destroy()
    pass

def ChoixServeurs(arg=None):
    listeserveursactifs=[]
    t = Toplevel(None)
    t.grab_set()
    framehaut = Frame(t)
    potentiels = Text(framehaut,width=20,height = 10)
    potentiels.insert(1.0,'localhost\n')
    potentiels.insert(1.0,'a\n')
    potentiels.insert(1.0,'b\n')
    potentiels.insert(1.0,'192.168.1.1\n')
##     for i in range(1,15):
##         potentiels.insert(1.0,"info1-%d\n"%i)
##     for i in range(1,12):
##         potentiels.insert(1.0,"info4-%d\n"%i)
        
    actifs =  Listbox(framehaut)
    #buttonselect = Button(framehaut,text='>')
    
    potentiels.grid(row=0,column=0)
    actifs.grid(row=0,column=1)
    #buttonselect.grid(row=0,column=2)
    framehaut.grid(row=0,column=0)

    framebas = Frame(t)
    buttonok = Button(framebas,text=' ok ',command = lambda x = listeserveursactifs,tt=t : ChoixServeurs_bok(x,tt) )
    buttondetect = Button(framebas,text='detect',command=lambda x=potentiels,y=actifs,r=listeserveursactifs : DetectionServers(x,y,r))
    buttoncancel = Button(framebas,text='cancel',command = t.destroy)
    buttonok.grid(row=0,column=0)
    buttondetect.grid(row=0,column=1)
    buttoncancel.grid(row=0,column=2)
                  
    framebas.grid(row=1,column=0) 
    
    root.wait_window(t)
    



def Configure(arg=None,aa=0):
    """ la fenetre de configuration de povedit existe dj. Elle a t iconise
    Il suffit de la deiconiser"""
    import detection
    root.withdraw()
    detect = Global.detect
    detect.toplevel.deiconify()
    root.wait_variable(Global.n)
    root.deiconify()

def AffecteBoutons(arg=None):
    """ permet de selectionner la fonctions associees aux boutons"""
    from AffectationBoutons import AffecteBoutons as AffecteBoutons
    c =AffecteBoutons(None,"popo")
    root.wait_window(c.top)




def ShowToolBar(arg=None):
    val = Interface.ShowToolBar.get()
    if not val : Interface.frame1.grid_forget()
    else : Interface.frame1.grid(row=1,column=0,sticky=N+S+W+E)



def PortFolio(arg=None):
    import gestionimages
    Global.PortFolio = gestionimages.Portfolio(root)



def clean():
    GetCurrentEditor.delete(1.0,END)
    




def ChercheMot(DebutMot,ListeMots):
    Resu = []
    for mot in ListeMots :
        if mot.find(DebutMot) == 0 : Resu.append(mot[len(DebutMot):])
    return Resu


###################### fin de menu8 ################################



##############################   MENU 9   #########################################

def ExecuteAddOn(arg=None):
    from addon import addon as addon
    f = addon(root)
    f.top.grab_set()
    root.wait_window(f.top)
    """ execute un programme externe, et en insere la sortie dans l'editeur courant"""
    s = "%s%sAddons%s%s"%(POVEDITHOME,os.sep,os.sep,Global.StringToFind)
    print s
    (child_stdin, child_stdout, child_stderr) = os.popen3(s)
    editor = GetCurrentEditor()
    editor.insert(INSERT,child_stdout.read())
    
###################### fin de menu9 ################################

##############################   MENU 10   #########################################
###################### fin de menu10 ################################


##############################   MENU 11   #########################################



def About(arg=None):
    from  about import About as About
    c = About(None,"mlkmlk")
    root.wait_window(c.top)


###################### fin de menu11 ################################



#########################  debut bindings  ################################
    
def Completion(arg=None):
    """ bind F9 """
    from data import ListeMots as ListeMots
    editor = GetCurrentEditor()
    str = editor.index(INSERT)
    (li,co) = str.split('.')
    #print li,co
    if co == '0' :
        Pmw.MessageDialog(None,defaultbutton = 0,message_text = povmessages[9])
        return
    j = int(co) - 1
    if editor.get("%s.%d"%(li,j)) == ' ' :
        Pmw.MessageDialog(None,defaultbutton = 0,message_text =povmessages[9])
        return
    DebutLigne = editor.get("%s.0"%li,INSERT)
    #ce qu'il y a avant le curseur
    IndDebutMot=0
    for j in range(int(co)):
        if editor.get("%s.%d"%(li,j)) == ' ' : IndDebutMot = j+1
    DebutMot = editor.get("%s.%d"%(li,IndDebutMot),INSERT)
    resu = ChercheMot(DebutMot,ListeMots)
    if len(resu) == 1 :
        editor.insert(INSERT,resu[0])
        return
    if len(resu) > 1 :
        return
        editor.insert(INSERT,resu[0])
        editor.tag_add('XXX',"%s.%d"%(li,int(co)),"%s.%d"%(li,int(co)+5))
        editor.tag_config('XXX',foreground='red')
        return
    
    


  
## class MyDialog1:
##     def __init__(self, parent):
##         top = self.top = Toplevel(parent)
##         Label(top, text="Value").pack()
##         self.e1 = Entry(top)
##         self.e1.pack(padx=5)
##         Label(top, text="Value").pack()
##         self.e2 = Entry(top)
##         self.e2.pack(padx=5)
##         b = Button(top, text="OK", command=self.ok)
##         b.pack(pady=5)

##     def ok(self):
##         Global.StringToFind =  self.e1.get()+self.e2.get()
##         self.top.destroy()

  


## def Ask(typeentree):
##     import dialogs
##     if typeentree == 0 : t=dialogs.Find(None)
    
##     elif  typeentree == 1 : t=dialogs.MyDialog1(None)
##     root.wait_window(t.top)




def color(rg=None):
    """ bind Return"""
    import analyse,re

    num =Global.Interface.notebook.index(Pmw.SELECT)
    editor = GetCurrentEditor()
    s = editor.get(1.0, END)
    if Interface.Config_ShowWhiteSpace.get()  == 1 :
        s = ShowWhiteSpace(s)
        editor.delete(1.0,END)
        editor.insert(1.0,s)
    
    PileEtats = Interface.ListePileEtats[num]
    PileEtats.append(s)
    #Interface.ListeEtats[num] = Interface.ListeEtats[num]  + 1
    tabs = analyse.findall(analyse.comment1,s)
    editor.tag_remove("clignotant",1.0, END)
    #les commentaires
    editor.tag_remove("a",1.0, END)
    for x in tabs :
        editor.tag_add("a", "1.0 + %d  chars"%x[0],"1.0 + %d  chars"%x[1])
        editor.tag_config("a", foreground="gray")
    tabs = analyse.findall(analyse.comment,s)
    editor.tag_remove("b",1.0, END)
    for x in tabs :
        editor.tag_add("b", "1.0 + %d  chars"%x[0],"1.0 + %d  chars"%x[1])
        editor.tag_config("b", foreground="gray")
    #les mots cles 1
    tabs = analyse.findall(analyse.kw,s)
    
    editor.tag_remove("c",1.0, END)
    for x in tabs :
        editor.tag_add("c", "1.0 + %d  chars"%x[0],"1.0 + %d  chars"%x[1])
        editor.tag_config("c", foreground="red", underline=1)
    tabs = analyse.findall(analyse.kw1,s)
    editor.tag_remove("d",1.0, END)
    for x in tabs :
        editor.tag_add("d", "1.0 + %d  chars"%x[0],"1.0 + %d  chars"%x[1])
        editor.tag_config("d", foreground="blue", underline=1)
        


# le binding sur les icones actives... Inutilisable...
def xxx(Arg=None):
    print "bbb"
    name  = Arg.widget.cget('text')
    #on cherche la position du widget dans la liste Global.SElectedIcons
    pos = Global.SelectedIcons.index(name)
    if pos == 0 : return
    prevname = Global.SelectedIcons[pos-1]
    #on recherche les positions correspondantes a name et a prevname
    for i in range(len( Global.image)):
        if Global.image[i][1].find(name) >= 0 : break
    posname = i
    for i in range(len( Global.image)):
        if Global.image[i][1].find(prevname) >= 0 : break
    posprevname = i
    im1 =  Global.image[posprevname]
    im2 =  Global.image[posname]
    Global.image[posname] = im1
    Global.image[posprevname] = im2
    #Arg.widget.flash()
    Global.Interface.frame1.forget()
    Global.Interface.CreateBBar()
    






#########################  fin  bindings  ################################




def CreatePopup():
    """ appele  l'initialisation, pour crer le menu d'insertion d'un objet"""
    import glob,os.path
    global menu
    menu = Menu(None, tearoff=0)
    menu.add_command(label="cancel")
    homedir = os.path.expanduser('~')
    workdir = os.getcwd()
    l = glob.glob(POVEDITHOME+'/Insert_Menu/')
    #print l
    if len(l) :
        importedir(l[0],menu)
        return 1
    return 0


#fonction liee au menu cree par CreatePopup
def LectureFichier(a=None):
    edit = GetCurrentEditor()
    edit.insert(INSERT,open(a).read())
    color()





def importedir(dirname,menu):
    import os,os.path
    listeobjets = os.listdir(dirname)
    for x in listeobjets :
        longname = os.path.join(dirname,x)
        if os.path.isdir(longname) :
            menu1 = Menu(menu)
            menu.add_cascade(label=x,menu=menu1)
            importedir(longname,menu1)
        if os.path.isfile(longname) :
            if x[-3:] == 'txt' or  x[-3:] == 'pov' :
                menu.add_command(label=x,command= lambda n=longname : LectureFichier(n))

    


    
## def com0():
##     eval(Global.function[0]+"()")
## def com1():
##     eval(Global.function[1]+"()")
## def com2():
##     eval(Global.function[2]+"()")
## def com3():
##     eval(Global.function[3]+"()")
## def com4():
##     eval(Global.function[4]+"()")
## def com5():
##     eval(Global.function[5]+"()")
## def com6():
##     eval(Global.function[6]+"()")
## def com7():
##     eval(Global.function[7]+"()")


def CreateBindings(t):
    t.bind("<Control-e>", SelectFont)
    t.bind("<Button-3>", Inserer)
    t.bind("<Control-Button-3>",SelectFont )
    t.bind("<Shift-Button-3>",Visu )
    t.bind("<Return>", color)
    #t.bind("<F4>", vv)
    #il y  deja un binding sur root
    t.bind("<Alt-h>", Montrer )
    t.bind("<Control-h>", Hide )
    t.bind("<Alt-a>", SelectAll )
    t.bind("<F9>", Completion )
    t.bind("<Control-r>", Visu )
    t.bind("<Control-u>", Undo )
    t.bind("<Control-r>", Redo )
    t.bind("<Control-c>", Copy )
    t.bind("<Control-v>", Paste )
    t.bind("<Control-x>", Cut)
    t.bind("<Control-z>", Delete)
    t.bind("<Control-f>", Find)
    t.bind("<Control-g>", GotoLine)
    t.bind("<Control-b>", MatchBrace)
    t.bind("<Control-k>", KillAll)
    t.bind("<Control-p>", PortFolio)



def AddPage(filename,loadfile,I = None,content = None):
    """ ajoute un editeur
    arguments : le path du fichier a charger s'il y a lieu
    si loadfile est egal a 1, le fichier est charge"""
    if I == None : I=Interface
    notebook = I.notebook
    ListEditors = I.ListEditors
    editorname = filename.split('/').pop().replace('_','-').replace('.','*')
    
    page1 = notebook.add(editorname)
    import ScrolledText
    editor = ScrolledText.ScrolledText(page1)
    #editor = Text(page1)
    #editor.grid(row=0,column=0)
    editor.configure(exportselection='true',bg="white",height=50)
    editor.pack(fill=BOTH)
    CreateBindings(editor)
    editor.configure(tabs=10)
    ListEditors.append(editor)
    I.ListFileNames.append(filename)
    if loadfile == 1 :
        editor.insert(0.1,open(filename).read())
    if content :
        editor.insert(0.1,content)
    #txt1.yview(7.0)
    notebook.selectpage(editorname)
    return editor



  

class POVInterface:
    def __init__(self,parent,SZ):
        self.parent = root
        self.BBar = []
        self.Quality = IntVar()
        self.Quality.set(5)
        self.VariablePourFind = IntVar()
        self.VariablePourGotoLine = IntVar()
        import Pmw
        self.balloon = Pmw.Balloon(parent)
        self.ListeEtats=[0,0,0,0,0,0,0,0,0,0,0,0,0]
        self.ListePileEtats= [[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[]]
        self.ListEditors = []
        self.ListFileNames =  []
        self.mainwindow = parent
        self.function = [MatchBrace,Hide,Montrer,None,Exit]
        self.PortFolio = IntVar(0)
        self.Config_ShowWhiteSpace = IntVar(0)
        self.Config_SetRepeatCount = IntVar(0) 
        self.ShowToolBar = IntVar();self.ShowToolBar.set(1)


        #creation du menu
        #print Global.police
        self.menubar = Menu(self.mainwindow)
        menu1  = Menu(self.menubar)
        menu1_1  = Menu(self.menubar)
        menu2  = Menu(self.menubar)
        menu2_1 = Menu(self.menubar)
        menu3  = Menu(self.menubar)
        menu4  = Menu(self.menubar)
        menu4_1 = Menu(self.menubar)
        menu4_2 = Menu(self.menubar)
        menu4_3 = Menu(self.menubar)
        menu5  = Menu(self.menubar)
        menu7  = Menu(self.menubar)
        menu7_1  = Menu(self.menubar)
        menu7_2  = Menu(self.menubar)
        menu7_3  = Menu(self.menubar)
        menu7_4  = Menu(self.menubar)
        menu7_5  = Menu(self.menubar)
        menu7_6  = Menu(self.menubar)
        menu8  = Menu(self.menubar)
        menu8_1  = Menu(self.menubar)
        menu8_2  = Menu(self.menubar)
        menu9  = Menu(self.menubar)
        menu10 = Menu(self.menubar)
        menu11 = Menu(self.menubar)

	self.menubar.add_cascade(label=povmessages[11],menu=menu1)
        self.menubar.add_cascade(label=povmessages[12],menu=menu2)
	self.menubar.add_cascade(label=povmessages[13],menu=menu3)
        self.menubar.add_cascade(label=povmessages[14],menu=menu4)
	self.menubar.add_cascade(label=povmessages[15],menu=menu5)
        self.menubar.add_command(label=povmessages[16],command=Inserer)
	self.menubar.add_cascade(label=povmessages[17],menu=menu7)
        self.menubar.add_cascade(label=povmessages[18],menu=menu8)
	self.menubar.add_cascade(label=povmessages[19],menu=menu9)
        self.menubar.add_cascade(label=povmessages[20],menu=menu10)
	self.menubar.add_cascade(label=povmessages[21],menu=menu11)

        self.mainwindow.config(menu=self.menubar)


        
        menu1.add_command(label=povmessages[22],state='disabled')
        menu1.add_separator()
        menu1.add_command(label=povmessages[23],command=NewFile)
        menu1.add_command(label=povmessages[24],command=OpenFile)
        menu1.add_command(label=povmessages[40],command=InsertFile)
        menu1.add_separator()
        menu1.add_command(label=povmessages[25],command=Close)
        menu1.add_command(label=povmessages[26],command=CloseAll)
        menu1.add_separator()
        menu1.add_command(label=povmessages[27],command=Save)
        menu1.add_command(label=povmessages[28],command=SaveAs)
        menu1.add_command(label=povmessages[29],command=SaveAll)
        menu1.add_separator()
        menu1.add_command(label=povmessages[30],command=Print)
        menu1.add_command(label=povmessages[31],command=NotImplemented)
        menu1.add_separator()
        menu1.add_command(label=povmessages[32],command=Exit)
        menu1.add_separator()
        menu1.add_cascade(label=povmessages[33],menu=menu1_1)
	homedir = os.path.expanduser('~')
        Dic= {}
	try :
            import pickle
            f = open(homedir+'/.poveditrc/Oldfiles')
            Dic = pickle.load(f)
            for k in Dic.keys():
                menu1_1.add_command(label=k,command = lambda nn = Dic[k] : AddPage(nn,1))
        except : pass

        menu2.add_command(label=povmessages[22],command=NotImplemented,state='disabled')
        menu2.add_separator()
        menu2.add_command(label=povmessages[34],command=Undo)
        menu2.add_command(label=povmessages[35],command=Redo)
        menu2.add_separator()
        menu2.add_command(label=povmessages[36],command=Cut)
        menu2.add_command(label=povmessages[37],command=Copy)
        menu2.add_command(label=povmessages[38],command=Paste)
        menu2.add_command(label=povmessages[39],command=Delete)
        menu2.add_command(label=povmessages[41],command=Hide)
        menu2.add_command(label=povmessages[42],command=Montrer)
        menu2.add_separator()
        menu2.add_command(label=povmessages[43],command=SelectAll)
        menu2.add_cascade(label="Selection",menu = menu2_1)
        menu2_1.add_command(label="Indent Tab",state='disabled')
        menu2_1.add_command(label="Indent to Previous",state='disabled')
        menu2_1.add_command(label="Undent Tab",state='disabled')
        menu2_1.add_command(label=povmessages[44],command = UpperCase)
        menu2_1.add_command(label=povmessages[45],command=LowerCase)
        menu2_1.add_command(label=povmessages[64],command=SpaceToTabs)
        menu2_1.add_command(label=povmessages[65],command=TabsToSpace)
        
        menu3.add_command(label=povmessages[22],state='disabled')
        menu3.add_command(label=povmessages[46],command=Find)
        menu3.add_command(label=povmessages[47],command=Replace)
        menu3.add_command(label=povmessages[48],command=FindNext)
        menu3.add_separator()
        menu3.add_command(label=povmessages[49],command=MatchBrace)
        menu3.add_command(label=povmessages[50],command = GotoLine)
        
        menu4.add_command(label=povmessages[22],state='disabled')
        menu4.add_checkbutton(label=povmessages[51],selectcolor='red',variable = self.Config_ShowWhiteSpace)
        menu4.add_command(label=povmessages[52],command=SetRepeatCount )
        menu4.add_command(label="Tab Size ",state='disabled')
        menu4.add_separator()
        menu4.add_cascade(label="Indent",menu = menu4_1,state='disabled')
        menu4.add_cascade(label="Auto Indent Style",menu = menu4_2,state='disabled')
        menu4.add_cascade(label="BookMarks",menu = menu4_3,state='disabled')


        self.popo = IntVar()
        menu5.add_command(label=povmessages[22],state='disabled')
        menu4.add_separator()
        menu5.add_checkbutton(label="Autoload Error File",state='disabled',variable = self.popo)
        menu5.add_checkbutton(label="Autoshow parse messages",state='disabled',variable = self.popo)
        menu5.add_command(label="Autosave delay...",state='disabled')
        menu5.add_separator()
        menu5.add_checkbutton(label="Create backups",state='disabled',variable = self.popo)
        menu5.add_checkbutton(label="Allow undo after man. save",state='disabled',variable = self.popo)
        menu5.add_checkbutton(label="Click beyond eol",state='disabled',variable = self.popo)
        menu5.add_checkbutton(label="Constraint caret to text",state='disabled',variable = self.popo)

        
        #pas de menu6, c'est une commande
        menu7.add_command(label=povmessages[22],state='disabled')
        menu7.add_command(label=povmessages[53],command=EditSettingsRender)
        menu7.add_command(label=povmessages[54],command=SelectFileAndRender)
        menu7.add_command(label=povmessages[55],command = Visu)
        menu7.add_command(label=povmessages[70],command = Visu1)
        menu7.add_command(label=povmessages[56],command = Controle)
        menu7.add_command(label=povmessages[57],command = KillAll)
        menu7.add_separator()
        menu7.add_command(label="Run Demo",state='disabled')
        menu7.add_command(label="Run Benchmark",state='disabled')
        menu7.add_separator()
        menu7.add_checkbutton(label="Auto Render",state='disabled')
        menu7.add_command(label="File Queue",state='disabled')
        menu7.add_command(label="Clear Queue",state='disabled')
        menu7.add_separator()
        menu7.add_cascade(label="GUI Priority",state='disabled',menu=menu7_1)
        menu7.add_cascade(label="Render Priority",state='disabled',menu=menu7_2)
        menu7.add_cascade(label="Duty Cycle",state='disabled',menu=menu7_3)
        menu7.add_separator()
        menu7.add_cascade(label="Animation",state='disabled',menu=menu7_4)
        menu7.add_cascade(label="On Completion",state='disabled',menu=menu7_5)
        menu7.add_cascade(label="Rerun",state='disabled',menu=menu7_6)


        menu8.add_command(label=povmessages[22],state='disabled')
        menu8.add_separator()
        menu8.add_command(label=povmessages[68],command=LancerServeur)
        menu8.add_command(label=povmessages[69],command=ChoixServeurs)
        menu8.add_command(label=povmessages[66],command=Configure)
        menu8.add_command(label=povmessages[67],command=AffecteBoutons)
        menu8.add_command(label="Keep single instance",state='disabled')
        menu8.add_command(label="Use render animation ",state='disabled')
        menu8.add_command(label=povmessages[58],command = PortFolio)
        menu8.add_checkbutton(label=povmessages[62],selectcolor='red',variable=self.ShowToolBar,command=ShowToolBar)
        menu8.add_checkbutton(label=povmessages[63],variable = self.PortFolio,command=popo)
        menu8.add_command(label="Place in system tray ",state='disabled')
        menu8.add_separator()
        menu8.add_cascade(label="Script IO restrictions ",state='disabled',menu=menu8_1)
        menu8_1.add_command(label="No restrictions ",state='disabled')
        menu8_1.add_command(label="Allow read, Restrict write ",state='disabled')
        menu8_1.add_command(label="Restrect read and write ",state='disabled')
        menu8_1.add_separator()
        menu8_1.add_command(label="Permit read/write in the current directory",state='disabled')
        menu8_1.add_command(label="Disable starting other programs",state='disabled')
        menu8.add_cascade(label="Other settings",state='disabled',menu=menu8_2)
        menu8_2.add_checkbutton(label="Use editor",state='disabled')
        menu8_2.add_checkbutton(label="Use file browse template",state='disabled')
        menu8_2.add_checkbutton(label="Show tips of the day",state='disabled')
        menu8_2.add_checkbutton(label="Show tooltips",state='disabled')
        menu8_2.add_checkbutton(label="Preserve messages",selectcolor="green")
        menu8_2.add_checkbutton(label="Save settings on exit",state='disabled')
        menu8_2.add_checkbutton(label="Hide new user help",state='disabled')
        menu8_2.add_separator()
        menu8_2.add_command(label="Show next tip",state='disabled')
        menu8_2.add_checkbutton(label="Re render insert menu bitmaps",state='disabled')

        
        menu9.add_command(label=povmessages[22],state='disabled')
        menu9.add_command(label=povmessages[60],command = ExecuteAddOn )
        menu9.add_command(label="Reload tool menu",state='disabled')
        menu9.add_separator()
        menu9.add_command(label="Edit master povray.ini ",state='disabled')
        menu9.add_command(label="Edit PVengine.ini ",state='disabled')
        menu9.add_command(label="Edit last rendered file ",state='disabled')
        menu9.add_command(label="Edit last scene file",state='disabled')
        menu9.add_command(label="View last rendered file ",state='disabled')
        menu9.add_command(label="View histogram image file ",state='disabled')
        menu9.add_command(label="Edit resolution INI file ",state='disabled')
        menu9.add_command(label="Edit this menu ",state='disabled')
        
        menu10.add_command(label=povmessages[22],state='disabled')
        menu10.add_checkbutton(label="Use extensions",state='disabled')

        menu11.add_command(label="Help on POV-Ray",state='disabled')
        menu11.add_command(label=povmessages[71],command=MiseAJour)
        menu11.add_command(label="Bug reporting",state='disabled')
        menu11.add_command(label="Show tip",state='disabled')
        menu11.add_separator()
        menu11.add_command(label="Go to povray web site",state='disabled')
        menu11.add_command(label="Go to IRTC",state='disabled')
        menu11.add_separator()
        menu11.add_command(label="The IRTC cdrom",state='disabled')
        menu11.add_separator()
        menu11.add_command(label="povray legal statement and license",state='disabled')
        menu11.add_command(label=povmessages[61],command=About)



        #creation de la barre d'icones

        self.CreateBBar()


        #creation de la seconde barre
        self.frame2 = Frame(parent,bd=2,relief='ridge')
        
        self.frame2.scale = Scale(self.frame2,orient=HORIZONTAL,resolution=1,to=11,from_=1,width=8,variable = self.Quality)
        self.frame2.scale.grid(row=0,column=0,padx=5,pady=5,sticky=W)


        
        self.frame2.entry = Entry(self.frame2)
        self.frame2.entry.grid(row=0,column=2,padx=5,pady=5,sticky=W)

                               
        self.frame2.combo = Pmw.ComboBox(self.frame2)
        for x in Global.ListeOptions :
            if x == None : x = "Erreur lecture"
            self.frame2.combo.insert(END,x)
        self.frame2.combo.selectitem(0)
        self.frame2.combo.grid(row=0,padx = 5,pady=5,column=1,sticky=W)
        #self.frame2.combo.selectitem(0)
        
        self.checkalbumactif=Checkbutton(self.frame2,text=povmessages[72],variable=self.PortFolio,command=popo)
        self.checkalbumactif.grid(row = 0,column = 3,sticky = E)

        self.frame2.grid(row=3,column=0,sticky=N+S+W+E)


        
        #les editeurs
        #self.notebook = Pmw.NoteBook(self.mainwindow,hull_width=800,hull_height=700)
        if SZ == 'big' :
            self.notebook = Pmw.NoteBook(self.mainwindow,hull_width=800,hull_height=700)
        if SZ == 'small' :
            self.notebook = Pmw.NoteBook(self.mainwindow,hull_width=500,hull_height=400)
        self.notebook.grid(row=4,column=0,sticky="nswe")


            
    def CreateBBar(self):
        if Global.SelectedIcons == None or  len(Global.SelectedIcons) == 0:
            Global.SelectedIcons =['Hide','Find','Paste','Visu','MatchBrace','Configure','KillAll','Delete','NewFile','PortFolio','Exit']
        self.ImageButton={}
        #
        #creation de la barre de boutons et de la checkbox pour l'album
        #
        self.frame1 = Frame(self.parent,bd=2,relief='ridge')
        if Global.langue == 0 : from messages import frbulles as Bulles
        if Global.langue == 1 : from messages import enbulles as Bulles

        j = 0
        for funcname in  Global.SelectedIcons :
            I = None
            for i in Global.image :
                if i[1].split(os.sep)[-1].split('.')[0] == funcname : I = i
            if I == None : continue
            b = Button(self.frame1,text=funcname,image=I[0],command=eval(funcname))
            b.bind("<Control-Left>",xxx)
            self.BBar.append(b) #pour les dtruire
            b.grid(row = 0,column=j)
            self.balloon.bind(b, Bulles[funcname])
            j = j+1

        self.frame1.grid(row=1,column=0,sticky=N+S+W+E)


    def VerifieAdresses(self):
        if Global.AdresseDePOV == None :
            t=MyDialog(self.mainwindow,"L'adresse de l'executable povray n'est pas correcte\n Indiquez cette adresse (complete)")
            root.wait_window(t.top)
            Global.AdresseDePOV =Global.StringToFind
        if Global.AdresseIncludesPourPOV == None :
            t=MyDialog(self.mainwindow,"L'adresse du repertoire contenant les fichiers\n d'include pour POV n'est pas correcte.\n Indiquez cette adresse (complete)")
            root.wait_window(t.top)
            Global.AdresseIncludesPourPOV = Global.StringToFind
        

    def StartRender(self):
        self.VerifieAdresses()
        
        editor = GetCurrentEditor()
        data = editor.get(1.0, END)
        import analyse
        data  = analyse.ListFiles(data)
        for f in data :
            
            #x.close()
            import thread
            thread.start_new_thread(self.RunPov,(f,))
            import time
            time.sleep(1)
    

    def StartParallelRender(self):
        from socket import * 
        self.VerifieAdresses()
        num =Global.Interface.notebook.index(Pmw.SELECT)
        editor = Interface.ListEditors[num]
        data = editor.get(1.0, END)
        nserveurs = len( Global.ListeServeursActifs)
        numserv = 0
        #Il faut recuperer la largeur
        largeur = 150
        largeur = largeur / nserveurs
        for (sockobj,state) in Global.ListeServeursActifs :
            # tester state
            print "client envoie ",len(data)
            sockobj.send(data)#envoi du fichier pov
            ret1 = sockobj.recv(1024);print "serveur dit avoir recu ",ret1 #taille du fichier

            #les arguments sans le nom de fichier et sans l'adresse de pov
            OtherArgs = self.frame2.entry.get()
            s = "  +L"+Global.AdresseIncludesPourPOV
            if len(Global.IncludesPersonnels) > 0 : s = s + ' +L'+Global.IncludesPersonnels
            s = s + " "+Global.FichierConfigPPal+" "
            s = s + EntryToCmd(self.frame2.combo.entry.get())
            s = s + ' '+OtherArgs
            s = s + " +Q%d "%self.Quality.get()
            s = s + " +SR%d +ER%d "%(numserv*largeur,(numserv+1)*largeur)
            #envoi des options
            sockobj.send(s)
            #on recupere le fichier
            resu = ""
            for i in range(1000):
                ret1 = sockobj.recv(1024)
                resu = resu + ret1
                if len(ret1) == 0 : break
            print 'Client a recu ',len(resu)
            filename = "mm%d.tga"%numserv
            open(filename,"w+").write(resu)
            sockobj.close()
            numserv = numserv + 1

            
        
    def RunPov(self,povdata):
        import os
        fff = open('popo','w')
        fff.write(povdata)
        fff.close()
        OtherArgs = self.frame2.entry.get()
        s = Global.AdresseDePOV + "  +L"+Global.AdresseIncludesPourPOV
        if len(Global.IncludesPersonnels) > 0 : s = s + ' +L'+Global.IncludesPersonnels
        s = s + " "+Global.FichierConfigPPal+" "
        s = s + EntryToCmd(self.frame2.combo.component('entry').get())
        s = s + ' '+OtherArgs
        s = s + " +Q%d "%self.Quality.get()
        s = s + " +Ipopo"
  
        print "Rendu : ",s
##         audio = open("/dev/dsp","w")
##         audio.write(open("woow1.wav").read())
        
        (child_stdin, child_stdout, child_stderr) = os.popen3(s)


##         print len(povdata)
##         i = -1
##         blksize = 1000
##         f = open("/tmp/dbg","w")
##         for i in range(len(povdata)/blksize):
##             print i
##             print len(povdata[i*blksize:(i+1)*blksize])
##             try :
##                 child_stdin.write(povdata[i*blksize:(i+1)*blksize])
##             except IOError :
##                 print "mlml"
##             f.write(povdata[i*blksize:(i+1)*blksize])
##         print i
##         print len(povdata[(i+1)*blksize:])
##         child_stdin.write(povdata[(i+1)*blksize:])
##         f.write(povdata[(i+1)*blksize:])
##         child_stdin.flush()
##         child_stdin.close()
##         f.write('\n')
##         f.close()
        
        aa =  child_stdout.read()
        bb =  child_stderr.read()
        self.EditeurMessages.delete(1.0,END)
        self.EditeurMessages.insert('end',"Filesize %d\n\n"%len(aa))
        self.EditeurMessages.insert('end',bb)
        self.EditeurMessages.tag_add("d", "1.0 + %d  chars"%len(aa),END)
        self.EditeurMessages.tag_config("d", foreground="red")
        self.EditeurMessages.mark_set(INSERT,END)
        self.EditeurMessages.mark_set(CURRENT,END)

        if Global.Interface.PortFolio.get() == 1 :
            import os
            s = "convert -geometry 80x80! ppm:-   gif:-"
            (child_stdin, child_stdout, child_stderr) = os.popen3(s)
            child_stdin.write(aa)
            child_stdin.close()
            
            str = child_stdout.read()
            icon =  base64.encodestring(str)
            im = PhotoImage(data=icon)
            Global.rendu.append(im)
            Global.rendu_files.append(povdata)
            if Global.PortFolio != None :
                Global.PortFolio.makewidgets()
   
    def run(self):
        #self.mainwindow.geometry("800x813+0+0")
##         a = self.mainwindow.geometry()
##         newgeometry = a.split("+")[0]+"+0+0"
##         self.mainwindow.geometry(newgeometry)
        #Visu()
        self.mainwindow.mainloop()


    def ChooseColors(self):
        self.checkalbumactif.configure(selectcolor="green")




##################################################
#        FIN DE LA CLASSE
##################################################


if __name__ == '__main__':
    import base64
    global Interface
##     try :
##         import os
##         os.system("mkfifo pipe 2> /dev/null")
##     except : pass
    import os,os.path
    
    homedir = os.path.expanduser('~')
    if sys.platform == 'win32' :
        homedir='c:'
    PathRessources = homedir+'/.poveditrc'


    #destruction d'un hypothtique fichier .poveditrc, et cretion du repertoire
    #s'il n'existe pas
    if os.path.exists(PathRessources) and os.path.isfile(PathRessources) :
        os.unlink(PathRessources)
        os.mkdir(PathRessources)
        
        
    if not   os.path.exists(PathRessources)  :
        os.mkdir(PathRessources)
        





    IniFile = homedir+'/povedit.ini'
    if not   os.path.exists(IniFile)  :
        f = open(IniFile,"w+")
        f.write(";File created by povedit\n")
        f.write(";You'll probably want to change it\n")
        f.write(";Fichier cr par povedit\n")
        f.write(";Vous pouvez le modifier\n")
        f.write("\n\n+P +D")
        f.close





    root = Pmw.initialise()

    (maxx,maxy) = root.maxsize()
    
    CreatePopup()
    if maxx <= 800 or maxy <= 600 : SZ = 'small'
    else : SZ = 'big'
    root.geometry("800x813+0+0")
    ChargeImages(SZ)
    
    root.bind("<F4>", Visu)
    root.bind("<F5>", Visu1)
    root.bind("<Control-o>", OpenFile)
    root.bind("<Control-n>", NewFile)
    root.bind("<Control-s>", Save)
    root.bind("<Control-i>", InsertFile)
    root.bind("<Control-k>", Close)
    root.bind("<Control-Alt-k>", Close)
    root.bind("<Control-Shift-KeyPress-S>", SaveAll)
    root.bind("<Control-Alt-KeyPress-S>", SaveAs)

    # il faut lire la configuration AVANT de crer la fenetre Global.detect (tat withdraw, sera ventuellement
    # affiche sinon les variables de  detect sont remplies avec les valeurs autodtectes,
    # qui ne sont peut tre pas celles que l'utilisteur a indiques
    ResuLectureConfig = Global.read()
    n = IntVar()
    from detection import App as App
    detect = App(None,0,n)
    detect.toplevel.withdraw()
    Global.detect = detect
    Global.n = n
    
    # configuration obligatoire si on ne peut pas lire la config
    if not ResuLectureConfig :
        root.withdraw()
        Global.detect.toplevel.deiconify()
        root.wait_variable(n)
        root.deiconify()
    
            
    langue = Global.langue
    root.option_add("*Font",Global.police)
    root.option_add( '*Background', Global.maincolor)

    import messages
    if langue == 0 : from messages import frmessages as povmessages
    else : from messages import enmessages as povmessages
    Interface =  POVInterface(root,SZ)
    Global.Interface = Interface
    Global.root = root
    Interface.ChooseColors()
    Interface.EditeurMessages = AddPage("messages",0)
    try :
        AddPage("test1.pov",1)
    except :
        print "impossible ajouter page"
    if Global.splash :
         GetCurrentEditor().image_create(1.0,image = Global.splash)
         root.update_idletasks()
         import time
         time.sleep(.5)
         GetCurrentEditor().delete(Global.splash)
    
    Interface.run()
